//
//

#include "File.h"
#include <stdio.h>

using namespace Win32Utility;

int main(int argc, char* argv[])
{
	File file;
	char filePath[MAX_PATH];

	// t@C
	{
		DWORD num;
		num = file.SearchFile("C:\\*");
		printf("Searches [C:\\*]\n");
		for (DWORD i=0; i<num; i++) {
			if (FALSE != file.GetNextSearchedFile(filePath, sizeof(filePath))) {
				printf("+ [%s]\n", filePath);
			}
		}
		printf("End\n");
		printf("--------------\n");
	}
	// ut@CJv_CAO
	{
		if (FALSE != File::GetOpenFile(filePath, MAX_PATH)) {
			printf("Selected open-file [%s]\n", filePath);
		}
		printf("--------------\n");
	}
	// uOtĕۑv_CAO
	{
		if (FALSE != File::GetSaveFile(filePath, MAX_PATH)) {
			printf("Selected save-file [%s]\n", filePath);
		}
		printf("--------------\n");
	}
	// st@C
	{
		if (FALSE != File::GetExeFile(filePath, MAX_PATH)) {
			printf("Executing file [%s]\n", filePath);
		}
		if (FALSE != File::GetExeFolder(filePath, MAX_PATH)) {
			printf("Executing folder [%s]\n", filePath);
		}
		printf("--------------\n");
	}
	// ItH_̎擾
	{
		if (FALSE != file.GetFolder(filePath)) {
			printf("Folder [%s]\n", filePath);
		}
	}
	{
		char newFile1[] = "C:\\Users\\Public\\test1.txt\0";
		char newFile2[] = "C:\\Users\\Public\\test2.txt\0";
		char newFile3[] = "C:\\Users\\Public\\test3.txt\0";
		char newFile4[] = "C:\\Users\\Public\\test4.txt\0";
		HANDLE hFile = CreateFile(newFile1, 0, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
		if (INVALID_HANDLE_VALUE != hFile) {
			CloseHandle(hFile);
			printf("Created a file [%s] \n", newFile1);

			// t@C̎擾
			char typeName[80]={};
			char displayName[MAX_PATH]={};
			if (FALSE != file.GetFileInfo(newFile1, typeName, displayName)) {
				printf("FileType=[%s] DisplayName=[%s] \n", typeName, displayName);
			}

			// t@C̃Rs[
			if (FALSE != file.CopyFile(newFile1, newFile2)) {
				printf("Copied file [%s]=[%s] \n", newFile1, newFile2);
			}

			// t@C̖OύX
			if (FALSE != file.RenameFile(newFile1, newFile3)) {
				printf("Renamed file [%s]->[%s] \n", newFile1, newFile3);
			}

			// t@C̈ړ
			if (FALSE != file.MoveFile(newFile2, newFile4)) {
				printf("Movied file [%s]->[%s] \n", newFile2, newFile4);
			}

			// t@C̍폜
			if (FALSE != file.DeleteFile(newFile1, FALSE)) {
				printf("Deleted file [%s] \n", newFile1);
			}
			if (FALSE != file.DeleteFile(newFile2, FALSE)) {
				printf("Deleted file [%s] \n", newFile2);
			}
			if (FALSE != file.DeleteFile(newFile3, FALSE)) {
				printf("Deleted file [%s] \n", newFile3);
			}
			if (FALSE != file.DeleteFile(newFile4, TRUE)) {
				printf("Deleted file to RecycleBin [%s] \n", newFile4);
			}
		}
		printf("--------------\n");
	}

	return 0;
}

// EOF